
#include <windows.h>
#include <stdio.h>
#include <conio.h>

#include "isdll.h"

//
// Global Variables
//
HANDLE	handle;
ULONG	arg1=0, arg2=0, arg3=0;

//
// Function Declarations
//
void	DoR(void);
void	DoW(void);
void	DoI(void);
void	DoO(void);
void	DoS(void);

//=********************** main ****************************
//=********************************************************
int   main( int argc, char *argv[] )
{
	// Parse Command Line
	if( argc<2 )
	{
		printf("\nUsage: UNACCESS <op> <params ...>\n\n"
			   "  <op> - operation:\n"
			   "         r  - memory read\n"
			   "         w  - memory write\n"
			   "         i  - I/O port input\n"
			   "         o  - I/O port output\n"
			   "         s  - write to DOS screen area (adr B800:0000)\n"
			   "\n"
			   " Example:\n"
			   "         UNACCESS r <addr>\n"
			   "         UNACCESS w <addr> <val>\n"
			   "         UNACCESS i <port>\n"
			   "         UNACCESS o <port> <val>\n"
			   "         UNACCESS s <cnt>\n\n"
			   "         <addr> - hexadecimal physical address of memory\n"
			   "         <port> - hexadecimal physical address of I/O\n"
			   "         <val>  - hexadecimal value to write\n"
			   "         <cnt>  - hexadecimal byte counter\n"
			  );
		_getch();
		return 1;
	}

	char* endptr;
	if( argc >=3 )
		arg1 = strtoul(argv[2], &endptr, 16);
		//sscanf( argv[2], "%x", &arg1 );
	if( argc >=4 )
		arg2 = strtoul(argv[3], &endptr, 16);
		//sscanf( argv[3], "%x", &arg2 );
	if( argc >=5 )
		arg3 = strtoul(argv[4], &endptr, 16);
		//sscanf( argv[4], "%x", &arg3 );


	// Open UNINSYS Driver
	handle = UniDrv_Open(0);
	if( handle==0 )
	{
		printf("ISACCESS ERROR: Can't Open ISDRV\n\n" );
		_getch();
		return 1;
	}

	// Call Operation
	switch(toupper(argv[1][0]))
	{
		case 'R': DoR();	break;
		case 'W': DoW();	break;
		case 'I': DoI();	break;
		case 'O': DoO();	break;
		case 'S': DoS();	break;
		default:  
			printf("ISACCESS ERROR: Wrong operation mode\n\n" );
			break;
	}


	// Close UNINSYS Driver
	UniDrv_Close(handle);

	_getch();
	return 0;
}

//=********************** DoR ****************************
//=********************************************************
void	DoR(void)
{
	TRANSFER_DATA	trans;

	// Check Arguments
	if( arg1==0 )
	{
		printf("UNACCESS ERROR: physical addres is undefined \n\n");
		return;
	}

	// Dword Write
	trans.cmd = TCMD_RM_DWORD;
	trans.addr = arg1;
	if(0>UniDrv_Transfer( handle, &trans ))
		printf("UNACCESS ERROR: Bad execution of UniDrv_Transfer(TCMD_RM_DWORD)\n\n");
	else
		printf("UNACCES: addr=0x%X, val=0x%X\n", arg1, trans.data.dw ); 
	
	// You can also use next call
	//ULONG			val;
	//UniDrv_ReadDword( handle, arg1, &val );
}

//=********************** DoW ****************************
//=********************************************************
void	DoW(void)
{
	TRANSFER_DATA	trans;

	// Check Arguments
	if( arg1==0 )
	{
		printf("UNACCESS ERROR: physical address is undefined \n\n");
		return;
	}

	// Dword Write
	trans.cmd = TCMD_WM_DWORD;
	trans.addr = arg1;
	trans.data.dw = arg2;
	UniDrv_Transfer( handle, &trans );
	

	// You can also use next call
	//UniDrv_WriteDword( handle, arg1, arg2 );
}

//=********************** DoI ****************************
//=********************************************************
void	DoI(void)
{
	TRANSFER_DATA	trans;

	// Check Arguments
	if( arg1==0 )
	{
		printf("UNACCESS ERROR: physical address is undefined \n\n");
		return;
	}

/*
	// Debug Port Access
	if( arg3!=0 )
	{
		for(;;)
		{
			trans.cmd = TCMD_RP_DWORD;
			trans.addr = arg1;
			UniDrv_Transfer( handle, &trans );
			if( kbhit() ) break;
			printf("o");
		}
	}
*/

	// Dword Write
	trans.cmd = TCMD_RP_DWORD;
	trans.addr = arg1;
	if(0>UniDrv_Transfer( handle, &trans ))
		printf("UNACCESS ERROR: Bad execution of UniDrv_Transfer(TCMD_RM_DWORD)\n\n");
	else
		printf("UNACCES: addr=0x%X, val=0x%X\n", arg1, trans.data.dw ); 
	
	// You can also use next call
	//ULONG			val;
	//UniDrv_Inpd( handle, (USHORT)arg1, &val );
}

//=********************** DoO ****************************
//=********************************************************
void	DoO(void)
{
	TRANSFER_DATA	trans;

	// Check Arguments
	if( arg1==0 )
	{
		printf("UNACCESS ERROR: physical addres is undefined \n\n");
		return;
	}

	// Dword Write
	trans.cmd = TCMD_WP_DWORD;
	trans.addr = arg1;
	trans.data.dw = arg2;
	UniDrv_Transfer( handle, &trans );
	

	// You can also use next call
	//UniDrv_Outpd( handle, (USHORT)arg1, arg2 );
}

//=********************** DoS *****************************
//=********************************************************
void	DoS(void)
{
	TRANSFER_DATA	trans;
	ULONG			i;
	UCHAR			block[1024];
	int				loop;

	if( arg1==0 )
		arg1=3*80;
	if( arg1>1024 )
		arg1=1024;
	for( loop=0; ;loop++ )
	{
		// Dwords Write
		for( i=0; i<arg1; i++ )
			block[i] = 0x5A;
		trans.cmd = TCMD_WM_BYTES;
		trans.addr = 0xB8000;
		trans.data.addr = block;
		trans.size = arg1;
		UniDrv_Transfer( handle, &trans );

		// Break loop
		if( _kbhit() ) 
		{
			_getch();
			break;
		}
		printf( "Loop = %d\r", loop );
	}
}




//
// End of File
//
